----------------------------------------------------------------------
-- Created by Actel SmartDesign Thu Sep 23 11:08:26 2010
-- Testbench Template
-- This is a basic testbench that instantiates your design with basic 
-- clock and reset pins connected.  If your design has special
-- clock/reset or testbench driver requirements then you should 
-- copy this file and modify it. 
----------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity testbench is
end testbench;

architecture behavioral of testbench is

    constant SYSCLK_PERIOD : time := 100 ns;

    signal SYSCLK : std_logic := '0';
    signal NSYSRESET : std_logic := '0';

    component A2Fxxx_kit_demo
        -- ports
        port( 
            -- Inputs
            UART_0_RXD : in std_logic;
            MSS_RESET_N : in std_logic;
            HallFX1_603 : in std_logic;
            SDO_262 : in std_logic;
            HallFX2_603 : in std_logic;
            VM262_FPGA : in std_logic;
            HallFX3_603 : in std_logic;
            CUR1_603 : in std_logic;
            CUR2_603 : in std_logic;
            CUR3_603 : in std_logic;
            VM603_FPGA : in std_logic;
            VAREF0 : in std_logic;
            VAREF1 : in std_logic;
            HALL3 : in std_logic;
            HALL1 : in std_logic;
            HALL2 : in std_logic;
            PB2 : in std_logic;
            PB1 : in std_logic;

            -- Outputs
            UART_0_TXD : out std_logic;
            MSSIO_15_CLR_ERR_603 : out std_logic;
            MSSIO_14_ENABLE_TRI_603 : out std_logic;
            MSSIO_13_SENSE_HI_603 : out std_logic;
            MSSIO_12_SAMPLEx_603 : out std_logic;
            MSSIO_11_SCCLK_603 : out std_logic;
            MSSIO_10_SDI_262 : out std_logic;
            MSSIO_9_SCK_262 : out std_logic;
            MSSIO_8_ENN_262 : out std_logic;
            MSSIO_7_CLK_262 : out std_logic;
            MSSIO_5_CSN_262 : out std_logic;
            MSSIO_3_STEP_262 : out std_logic;
            MSSIO_1_DIR_262 : out std_logic;
            BH1_603 : out std_logic;
            BH3_603 : out std_logic;
            LED3 : out std_logic;
            BH2_603 : out std_logic;
            BL2_603 : out std_logic;
            BL3_603 : out std_logic;
            LED1 : out std_logic;
            LED4 : out std_logic;
            BL1_603 : out std_logic;
            LED2 : out std_logic;
            OLED_DCN : out std_logic;

            -- Inouts
            I2C_0_SCL : inout std_logic;
            I2C_0_SDA : inout std_logic

        );
    end component;

begin

    process
        variable vhdl_initial : BOOLEAN := TRUE;

    begin
        if ( vhdl_initial ) then
            -- Assert Reset
            NSYSRESET <= '0';
            wait for ( SYSCLK_PERIOD * 10 );
            
            NSYSRESET <= '1';
            wait;
        end if;
    end process;

    -- 10MHz Clock Driver
    SYSCLK <= not SYSCLK after (SYSCLK_PERIOD / 2.0 );

    -- Instantiate Unit Under Test:  A2Fxxx_kit_demo
    A2Fxxx_kit_demo_0 : A2Fxxx_kit_demo
        -- port map
        port map( 
            -- Inputs
            UART_0_RXD => '0',
            MSS_RESET_N => NSYSRESET,
            HallFX1_603 => '0',
            SDO_262 => '0',
            HallFX2_603 => '0',
            VM262_FPGA => '0',
            HallFX3_603 => '0',
            CUR1_603 => '0',
            CUR2_603 => '0',
            CUR3_603 => '0',
            VM603_FPGA => '0',
            VAREF0 => '0',
            VAREF1 => '0',
            HALL3 => '0',
            HALL1 => '0',
            HALL2 => '0',
            PB2 => '0',
            PB1 => '0',

            -- Outputs
            UART_0_TXD =>  open,
            MSSIO_15_CLR_ERR_603 =>  open,
            MSSIO_14_ENABLE_TRI_603 =>  open,
            MSSIO_13_SENSE_HI_603 =>  open,
            MSSIO_12_SAMPLEx_603 =>  open,
            MSSIO_11_SCCLK_603 =>  open,
            MSSIO_10_SDI_262 =>  open,
            MSSIO_9_SCK_262 =>  open,
            MSSIO_8_ENN_262 =>  open,
            MSSIO_7_CLK_262 =>  open,
            MSSIO_5_CSN_262 =>  open,
            MSSIO_3_STEP_262 =>  open,
            MSSIO_1_DIR_262 =>  open,
            BH1_603 =>  open,
            BH3_603 =>  open,
            LED3 =>  open,
            BH2_603 =>  open,
            BL2_603 =>  open,
            BL3_603 =>  open,
            LED1 =>  open,
            LED4 =>  open,
            BL1_603 =>  open,
            LED2 =>  open,
            OLED_DCN =>  open,

            -- Inouts
            I2C_0_SCL =>  open,
            I2C_0_SDA =>  open

        );

end behavioral;

